local Covenant = {
    Kyrian = 1,
    Venthyr = 2,
    NightFae = 3,
    Necrolord = 4
}

local Icon = {
    [Covenant.Kyrian] = "Interface\\AddOns\\Covenantie\\Media\\Kyrian",
    [Covenant.Necrolord] = "Interface\\AddOns\\Covenantie\\Media\\Necrolord",
    [Covenant.NightFae] = "Interface\\AddOns\\Covenantie\\Media\\NightFae",
    [Covenant.Venthyr] = "Interface\\AddOns\\Covenantie\\Media\\Venthyr"
}

local SPELLS = {
    DEATHKNIGHT = {
        [Covenant.Kyrian] = {
            [1] = 312202,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 311648,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 324128,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 315443,
            [2] = 324631
        }
    },
    DEMONHUNTER = {
        [Covenant.Kyrian] = {
            [1] = 306830,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 317009,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 323639,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 350570,
            [2] = 324631
        }
    },
    DRUID = {
        [Covenant.Kyrian] = {
            [1] = 326434,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 323546,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 323764,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 325727,
            [2] = 324631
        }
    },
    HUNTER = {
        [Covenant.Kyrian] = {
            [1] = 308491,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 324149,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 328231,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 325028,
            [2] = 324631
        }
    },
    MAGE = {
        [Covenant.Kyrian] = {
            [1] = 307443,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 314793,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 314791,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 324220,
            [2] = 324631
        }
    },
    MONK = {
        [Covenant.Kyrian] = {
            [1] = 310454,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 326860,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 327104,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 325216,
            [2] = 324631
        }
    },
    PALADIN = {
        [Covenant.Kyrian] = {
            [1] = 304971,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 316958,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 328620,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 328204,
            [2] = 324631
        }
    },
    PRIEST = {
        [Covenant.Kyrian] = {
            [1] = 325013,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 323673,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 327661,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 324724,
            [2] = 324631
        }
    },
    ROGUE = {
        [Covenant.Kyrian] = {
            [1] = 323547,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 323654,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 328305,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 328547,
            [2] = 324631
        }
    },
    SHAMAN = {
        [Covenant.Kyrian] = {
            [1] = 324386,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 320674,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 328923,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 326059,
            [2] = 324631
        }
    },
    WARLOCK = {
        [Covenant.Kyrian] = {
            [1] = 312321,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 321792,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 325640,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 325289,
            [2] = 324631
        }
    },
    WARRIOR = {
        [Covenant.Kyrian] = {
            [1] = 307865,
            [2] = 324739
        },
        [Covenant.Venthyr] = {
            [1] = 317320,
            [2] = 300728
        },
        [Covenant.NightFae] = {
            [1] = 325886,
            [2] = 310143
        },
        [Covenant.Necrolord] = {
            [1] = 324143,
            [2] = 324631
        }
    }
};

local Covenantie = {
    shown = false,
    loaded = false
}

function Covenantie:createButton(index)
    local button =
        CreateFrame("Button", "COVENANTIE_ABILITY_BUTTON_" .. index, self.frame, "SecureActionButtonTemplate");
    button.cooldown = CreateFrame("Cooldown", "COVENANTIE_ABILITY_COOLDOWN_" .. index, button, "CooldownFrameTemplate");
    button:SetWidth(35);
    button:SetHeight(35);

    return button;
end

function Covenantie:getMacro(index)
    local i = 1;
    while GetMacroInfo(i) do
        local name, icon, body = GetMacroInfo(i);
        if body ~= nil and string.find(body, "--Covenantie" .. tostring(index)) ~= nil then
            return i;
        end
        i = i + 1;
    end

    return nil;
end

function Covenantie:updateCovenant(covenantID)
    local _, className = UnitClass("player");
    local covenantID = covenantID or C_Covenants.GetActiveCovenantID();
    COVENANTIE_database.db.profile.minimap.icon = Icon[covenantID];
    self.icon:IconCallback('change', 'Covenantie', 'icon', COVENANTIE_database.db.profile.minimap.icon);
    local abilities = SPELLS[className][covenantID];
    self:setButton1(abilities[1]);
    self:setButton2(abilities[2]);
end

function Covenantie:OnLoad()
    self.buttons = {
        [1] = self:createButton(1),
        [2] = self:createButton(2)
    };
    if not COVENANTIE_database then
        COVENANTIE_database = {
            db = {
                profile = {
                    minimap = {
                        hide = false,
                        icon = "Interface\\AddOns\\Covenantie\\Media\\Icon"
                    }
                }
            }
        };
    end
    if self:getMacro(1) == nil then
        local macro = CreateMacro(" ", "INV_MISC_QUESTIONMARK", "--Covenantie1", nil);
        if macro == nil then
            print("Covenantie: Not enough free macro slots. Free some to allow Covenantie to work!")
        end
    end
    if self:getMacro(2) == nil then
        local macro = CreateMacro(" ", "INV_MISC_QUESTIONMARK", "--Covenantie2", nil);
        if macro == nil then
            print("Covenantie: Not enough free macro slots. Free some to allow Covenantie to work!")
        end
    end
    self.ldb = self:createLDB();
    self.icon = LibStub("LibDBIcon-1.0");
    self.icon:Register("Covenantie", self.ldb, COVENANTIE_database.db.profile.minimap);

    self:hide();
    self.buttons[1]:SetPoint('TOPLEFT', self.frame, 'TOPLEFT', 0, 0);
    self.buttons[2]:SetPoint('TOPLEFT', self.frame, 'TOPLEFT', 40, 0);
    self:updateCovenant();
end

function Covenantie:createFrame()
    local VARIABLES_LOADED = false;
    local ADDON_LOADED = false;
    local MACROS_UPDATED_COUNT = 0;
    local MACROS_UPDATED = false;
    local frame = CreateFrame("FRAME", "COVENANTIE_FRAME", UIParent)

    frame:SetWidth(80);
    frame:SetHeight(35);

    frame:RegisterEvent("ADDON_LOADED");
    frame:RegisterEvent("VARIABLES_LOADED");
    frame:RegisterEvent("UPDATE_MACROS");
    frame:RegisterEvent("COVENANT_CHOSEN");

    frame:SetScript("OnEvent", function(frame, event, arg1)
        if event == "ADDON_LOADED" and arg1 == "Covenantie" then
            ADDON_LOADED = true;
        end
        if event == "VARIABLES_LOADED" then
            VARIABLES_LOADED = true;
        end
        if event == "UPDATE_MACROS" then
            MACROS_UPDATED_COUNT = MACROS_UPDATED_COUNT + 1;
            if MACROS_UPDATED_COUNT >= 2 then
                MACROS_UPDATED = true;
            end
        end
        if ADDON_LOADED and VARIABLES_LOADED and MACROS_UPDATED and not self.loaded then
            self.loaded = true;
            self:OnLoad();
        end
        if self.loaded and event == "COVENANT_CHOSEN" then
            self:updateCovenant(arg1);
        end
    end);

    return frame;
end

function Covenantie:createLDB()
    local tooltip;
    return LibStub("LibDataBroker-1.1"):NewDataObject("Covenantie", {
        type = "data source",
        text = "Covenantie",
        icon = COVENANTIE_database.db.profile.minimap.icon,
        OnTooltipShow = function(tt)
            tooltip = tt;
            tooltip:SetText("Covenantie")
            tooltip:AddLine("Click to show/hide ability menu!", 1, 1, 1);
            tooltip:Show()
        end,
        OnClick = function(frame, button)
            if self.shown then
                self:hide()
            else
                if tooltip then
                    tooltip:Hide();
                end
                self:show(frame)
            end
        end
    })
end

function Covenantie:init()
    self.frame = self:createFrame();
end

function Covenantie:createMacro(index, spell)
    local showtooltip = "#showtooltip " .. spell .. "\n";
    local cast = "/cast " .. spell .. "\n";
    local tag = "--Covenantie" .. tostring(index);

    return showtooltip .. cast .. tag;
end

function Covenantie:setCooldown(button)
    local start, duration, enabled = GetSpellCooldown(button.spell);
    if enabled and enabled ~= 0 then
        button.cooldown:SetCooldown(start, duration);
    end
end

function Covenantie:setSpell(index, spell)
    local name, _, icon = GetSpellInfo(spell);
    local button = self.buttons[index];
    local macro = self:getMacro(index);

    macro = EditMacro(macro, " ", nil, self:createMacro(index, name), 1, nil);

    button.spell = spell;
    button:SetAttribute("type", "macro");
    button:SetAttribute("macro", macro);
    button:SetNormalTexture(icon);
    button:GetNormalTexture():SetAllPoints(button);

    self:setCooldown(button)

    button:SetScript("OnEnter", function(self)
        GameTooltip:SetOwner(self, "ANCHOR_CURSOR");
        GameTooltip:ClearLines();
        GameTooltip:SetSpellByID(spell);
        GameTooltip:Show()
    end)
    button:SetScript("OnLeave", function(self)
        GameTooltip:Hide()
    end)

    button:RegisterForDrag("LeftButton");
    button:SetScript("OnDragStart", function()
        PickupMacro(self:getMacro(index));
    end);
end

function Covenantie:setButton1(spell)
    self:setSpell(1, spell);
end

function Covenantie:setButton2(spell)
    self:setSpell(2, spell);
end

function Covenantie:show(frame)
    self.frame:SetPoint('TOP', frame, 'BOTTOM', 0, -10);
    self.frame:Show();
    self.shown = true;
end

function Covenantie:hide()
    self.frame:Hide();
    self.shown = false;
end

Covenantie:init();
